// CodeGear C++Builder
// Copyright (c) 1995, 2007 by CodeGear
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Idtelnet.pas' rev: 11.00

#ifndef IdtelnetHPP
#define IdtelnetHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Idassignednumbers.hpp>	// Pascal unit
#include <Idglobal.hpp>	// Pascal unit
#include <Idexception.hpp>	// Pascal unit
#include <Idstack.hpp>	// Pascal unit
#include <Idtcpclient.hpp>	// Pascal unit
#include <Idthread.hpp>	// Pascal unit
#include <Idtcpconnection.hpp>	// Pascal unit
#include <Idcomponent.hpp>	// Pascal unit
#include <Idbasecomponent.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Idtelnet
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TIdTelnetCommand { tncNoLocalEcho, tncLocalEcho, tncEcho };
#pragma option pop

class DELPHICLASS TIdTelnet;
typedef void __fastcall (__closure *TIdTelnetDataAvailEvent)(TIdTelnet* Sender, const Idglobal::TIdBytes Buffer);

typedef void __fastcall (__closure *TIdTelnetCommandEvent)(TIdTelnet* Sender, TIdTelnetCommand Status);

class DELPHICLASS TIdTelnetReadThread;
class PASCALIMPLEMENTATION TIdTelnetReadThread : public Idthread::TIdThread 
{
	typedef Idthread::TIdThread inherited;
	
protected:
	TIdTelnet* FClient;
	virtual void __fastcall Run(void);
	
public:
	__fastcall TIdTelnetReadThread(TIdTelnet* AClient);
	__property TIdTelnet* Client = {read=FClient};
public:
	#pragma option push -w-inl
	/* TIdThread.Destroy */ inline __fastcall virtual ~TIdTelnetReadThread(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TIdTelnet : public Idtcpclient::TIdTCPClientCustom 
{
	typedef Idtcpclient::TIdTCPClientCustom inherited;
	
protected:
	AnsiString fTerminal;
	bool fThreadedEvent;
	TIdTelnetDataAvailEvent FOnDataAvailable;
	bool fIamTelnet;
	TIdTelnetCommandEvent FOnTelnetCommand;
	TIdTelnetReadThread* FTelnetThread;
	void __fastcall DoOnDataAvailable(const Idglobal::TIdBytes Buf);
	__property bool IamTelnet = {read=fIamTelnet, write=fIamTelnet, nodefault};
	void __fastcall Negotiate(void);
	void __fastcall Handle_SB(const Byte SbType, const Idglobal::TIdBytes SbData);
	void __fastcall SendNegotiationResp(const Byte Response, const Byte ResponseData);
	void __fastcall SendSubNegotiationResp(const Byte SbType, const Idglobal::TIdBytes ResponseData);
	void __fastcall DoTelnetCommand(TIdTelnetCommand Status);
	virtual void __fastcall InitComponent(void);
	
public:
	__fastcall TIdTelnet(Classes::TComponent* AOwner)/* overload */;
	__fastcall virtual ~TIdTelnet(void);
	virtual void __fastcall Connect(void)/* overload */;
	virtual void __fastcall Disconnect(bool ANotifyPeer)/* overload */;
	void __fastcall SendCh(char Ch);
	void __fastcall SendString(const AnsiString S);
	__property TIdTelnetReadThread* TelnetThread = {read=FTelnetThread};
	
__published:
	__property Host ;
	__property Port  = {default=23};
	__property TIdTelnetCommandEvent OnTelnetCommand = {read=FOnTelnetCommand, write=FOnTelnetCommand};
	__property TIdTelnetDataAvailEvent OnDataAvailable = {read=FOnDataAvailable, write=FOnDataAvailable};
	__property AnsiString Terminal = {read=fTerminal, write=fTerminal};
	__property bool ThreadedEvent = {read=fThreadedEvent, write=fThreadedEvent, default=0};
	
/* Hoisted overloads: */
	
public:
	inline void __fastcall  Connect(const AnsiString AHost){ TIdTCPClientCustom::Connect(AHost); }
	inline void __fastcall  Connect(const AnsiString AHost, const Word APort){ TIdTCPClientCustom::Connect(AHost, APort); }
	inline void __fastcall  Disconnect(void){ TIdTCPConnection::Disconnect(); }
	
};


class DELPHICLASS EIdTelnetError;
class PASCALIMPLEMENTATION EIdTelnetError : public Idexception::EIdException 
{
	typedef Idexception::EIdException inherited;
	
public:
	#pragma option push -w-inl
	/* EIdException.Create */ inline __fastcall virtual EIdTelnetError(const AnsiString AMsg)/* overload */ : Idexception::EIdException(AMsg) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EIdTelnetError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : Idexception::EIdException(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EIdTelnetError(int Ident)/* overload */ : Idexception::EIdException(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EIdTelnetError(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : Idexception::EIdException(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EIdTelnetError(const AnsiString Msg, int AHelpContext) : Idexception::EIdException(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EIdTelnetError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : Idexception::EIdException(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EIdTelnetError(int Ident, int AHelpContext)/* overload */ : Idexception::EIdException(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EIdTelnetError(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : Idexception::EIdException(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EIdTelnetError(void) { }
	#pragma option pop
	
};


class DELPHICLASS EIdTelnetClientConnectError;
class PASCALIMPLEMENTATION EIdTelnetClientConnectError : public EIdTelnetError 
{
	typedef EIdTelnetError inherited;
	
public:
	#pragma option push -w-inl
	/* EIdException.Create */ inline __fastcall virtual EIdTelnetClientConnectError(const AnsiString AMsg)/* overload */ : EIdTelnetError(AMsg) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EIdTelnetClientConnectError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : EIdTelnetError(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EIdTelnetClientConnectError(int Ident)/* overload */ : EIdTelnetError(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EIdTelnetClientConnectError(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : EIdTelnetError(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EIdTelnetClientConnectError(const AnsiString Msg, int AHelpContext) : EIdTelnetError(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EIdTelnetClientConnectError(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : EIdTelnetError(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EIdTelnetClientConnectError(int Ident, int AHelpContext)/* overload */ : EIdTelnetError(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EIdTelnetClientConnectError(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : EIdTelnetError(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EIdTelnetClientConnectError(void) { }
	#pragma option pop
	
};


class DELPHICLASS EIdTelnetServerOnDataAvailableIsNil;
class PASCALIMPLEMENTATION EIdTelnetServerOnDataAvailableIsNil : public EIdTelnetError 
{
	typedef EIdTelnetError inherited;
	
public:
	#pragma option push -w-inl
	/* EIdException.Create */ inline __fastcall virtual EIdTelnetServerOnDataAvailableIsNil(const AnsiString AMsg)/* overload */ : EIdTelnetError(AMsg) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EIdTelnetServerOnDataAvailableIsNil(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size) : EIdTelnetError(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EIdTelnetServerOnDataAvailableIsNil(int Ident)/* overload */ : EIdTelnetError(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EIdTelnetServerOnDataAvailableIsNil(int Ident, System::TVarRec const * Args, const int Args_Size)/* overload */ : EIdTelnetError(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EIdTelnetServerOnDataAvailableIsNil(const AnsiString Msg, int AHelpContext) : EIdTelnetError(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EIdTelnetServerOnDataAvailableIsNil(const AnsiString Msg, System::TVarRec const * Args, const int Args_Size, int AHelpContext) : EIdTelnetError(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EIdTelnetServerOnDataAvailableIsNil(int Ident, int AHelpContext)/* overload */ : EIdTelnetError(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EIdTelnetServerOnDataAvailableIsNil(System::PResStringRec ResStringRec, System::TVarRec const * Args, const int Args_Size, int AHelpContext)/* overload */ : EIdTelnetError(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EIdTelnetServerOnDataAvailableIsNil(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
static const Byte TNC_EOR = 0xef;
static const Byte TNC_SE = 0xf0;
static const Byte TNC_NOP = 0xf1;
static const Byte TNC_DATA_MARK = 0xf2;
static const Byte TNC_BREAK = 0xf3;
static const Byte TNC_IP = 0xf4;
static const Byte TNC_AO = 0xf5;
static const Byte TNC_AYT = 0xf6;
static const Byte TNC_EC = 0xf7;
static const Byte TNC_EL = 0xf8;
static const Byte TNC_GA = 0xf9;
static const Byte TNC_SB = 0xfa;
static const Byte TNC_WILL = 0xfb;
static const Byte TNC_WONT = 0xfc;
static const Byte TNC_DO = 0xfd;
static const Byte TNC_DONT = 0xfe;
static const Byte TNC_IAC = 0xff;
static const Shortint TNO_BINARY = 0x0;
static const Shortint TNO_ECHO = 0x1;
static const Shortint TNO_RECONNECT = 0x2;
static const Shortint TNO_SGA = 0x3;
static const Shortint TNO_AMSN = 0x4;
static const Shortint TNO_STATUS = 0x5;
static const Shortint TNO_TIMING_MARK = 0x6;
static const Shortint TNO_RCTE = 0x7;
static const Shortint TNO_OLW = 0x8;
static const Shortint TNO_OPS = 0x9;
static const Shortint TNO_OCRD = 0xa;
static const Shortint TNO_OHTS = 0xb;
static const Shortint TNO_OHTD = 0xc;
static const Shortint TNO_OFD = 0xd;
static const Shortint TNO_OVT = 0xe;
static const Shortint TNO_OVTD = 0xf;
static const Shortint TNO_OLD = 0x10;
static const Shortint TNO_EA = 0x11;
static const Shortint TNO_LOGOUT = 0x12;
static const Shortint TNO_BYTE_MACRO = 0x13;
static const Shortint TNO_DET = 0x14;
static const Shortint TNO_SUPDUP = 0x15;
static const Shortint TNO_SUPDUP_OUTPUT = 0x16;
static const Shortint TNO_SL = 0x17;
static const Shortint TNO_TERMTYPE = 0x18;
static const Shortint TNO_EOR = 0x19;
static const Shortint TNO_TACACS_ID = 0x1a;
static const Shortint TNO_OM = 0x1b;
static const Shortint TNO_TLN = 0x1c;
static const Shortint TNO_3270REGIME = 0x1d;
static const Shortint TNO_X3PAD = 0x1e;
static const Shortint TNO_NAWS = 0x1f;
static const Shortint TNO_TERM_SPEED = 0x20;
static const Shortint TNO_RFLOW = 0x21;
static const Shortint TNO_LINEMODE = 0x22;
static const Shortint TNO_XDISPLOC = 0x23;
static const Shortint TNO_ENV = 0x24;
static const Shortint TNO_AUTH = 0x25;
static const Shortint TNO_ENCRYPT = 0x26;
static const Shortint TNO_NEWENV = 0x27;
static const Shortint TNO_TN3270E = 0x28;
static const Shortint TNO_XAUTH = 0x29;
static const Shortint TNO_CHARSET = 0x2a;
static const Shortint TNO_RSP = 0x2b;
static const Shortint TNO_COMPORT = 0x2c;
static const Shortint TNO_SUPLOCALECHO = 0x2d;
static const Shortint TNO_STARTTLS = 0x2e;
static const Shortint TNO_KERMIT = 0x2f;
static const Shortint TNO_SEND_URL = 0x30;
static const Shortint TNO_FORWARD_X = 0x31;
static const Byte TNO_PRAGMA_LOGON = 0x8a;
static const Byte TNO_SSPI_LOGON = 0x8b;
static const Byte TNO_PRAGMA_HEARTBEAT = 0x8c;
static const Byte TNO_EOL = 0xff;
static const Shortint TNOS_TERM_IS = 0x0;
static const Shortint TNOS_TERMTYPE_SEND = 0x1;
static const Shortint TNOS_REPLY = 0x2;
static const Shortint TNOS_NAME = 0x3;
static const Shortint TNOAUTH_IS = 0x0;
static const Shortint TNOAUTH_SEND = 0x1;
static const Shortint TNOAUTH_REPLY = 0x2;
static const Shortint TNOAUTH_NAME = 0x3;
static const Shortint TNOAUTH_NULL = 0x0;
static const Shortint TNOAUTH_KERBEROS_V4 = 0x1;
static const Shortint TNOAUTH_KERBEROS_V5 = 0x2;
static const Shortint TNOAUTH_SPX = 0x3;
static const Shortint TNOAUTH_MINK = 0x4;
static const Shortint TNOAUTH_SRP = 0x5;
static const Shortint TNOAUTH_RSA = 0x6;
static const Shortint TNOAUTH_SSL = 0x7;
static const Shortint TNOAUTH_LOKI = 0xa;
static const Shortint TNOAUTH_SSA = 0xb;
static const Shortint TNOAUTH_KEA_SJ = 0xc;
static const Shortint TNOAUTH_KEA_SJ_INTEG = 0xd;
static const Shortint TNOAUTH_DSS = 0xe;
static const Shortint TNOAUTH_NTLM = 0xf;
static const Shortint TNOAUTH_KRB4_AUTH = 0x0;
static const Shortint TNOAUTH_KRB4_REJECT = 0x1;
static const Shortint TNOAUTH_KRB4_ACCEPT = 0x2;
static const Shortint TNOAUTH_KRB4_CHALLENGE = 0x3;
static const Shortint TNOAUTH_KRB4_RESPONSE = 0x4;
static const Shortint TNOAUTH_KRB4_FORWARD = 0x5;
static const Shortint TNOAUTH_KRB4_FORWARD_ACCEPT = 0x6;
static const Shortint TNOAUTH_KRB4_FORWARD_REJECT = 0x7;
static const Shortint TNOAUTH_KRB4_EXP = 0x8;
static const Shortint TNOAUTH_KRB4_PARAMS = 0x9;
static const Shortint TNOAUTH_KRB5_AUTH = 0x0;
static const Shortint TNOAUTH_KRB5_REJECT = 0x1;
static const Shortint TNOAUTH_KRB5_ACCEPT = 0x2;
static const Shortint TNOAUTH_KRB5_RESPONSE = 0x3;
static const Shortint TNOAUTH_KRB5_FORWARD = 0x4;
static const Shortint TNOAUTH_KRB5_FORWARD_ACCEPT = 0x5;
static const Shortint TNOAUTH_KRB5_FORWARD_REJECT = 0x6;
static const Shortint TNOAUTH_DSS_INITIALIZE = 0x1;
static const Shortint TNOAUTH_DSS_TOKENBA = 0x2;
static const Shortint TNOAUTH_DSS_CERTA_TOKENAB = 0x3;
static const Shortint TNOAUTH_DSS_CERTB_TOKENBA2 = 0x4;
static const Shortint TNOAUTH_SRP_AUTH = 0x0;
static const Shortint TNOAUTH_SRP_REJECT = 0x1;
static const Shortint TNOAUTH_SRP_ACCEPT = 0x2;
static const Shortint TNOAUTH_SRP_CHALLENGE = 0x3;
static const Shortint TNOAUTH_SRP_RESPONSE = 0x4;
static const Shortint TNOAUTH_SRP_EXP = 0x8;
static const Shortint TNOAUTH_SRP_PARAMS = 0x9;
static const Shortint TNOAUTH_KEA_CERTA_RA = 0x1;
static const Shortint TNOAUTH_KEA_CERTB_RB_IVB_NONCEB = 0x2;
static const Shortint TNOAUTH_KEA_IVA_RESPONSEB_NONCEA = 0x3;
static const Shortint TNOAUTH_KEA_RESPONSEA = 0x4;
static const Shortint TNOENC_IS = 0x0;
static const Shortint TNOENC_SUPPORT = 0x1;
static const Shortint TNOENC_REPLY = 0x2;
static const Shortint TNOENC_START = 0x3;
static const Shortint TNOENC_END = 0x4;
static const Shortint TNOENC_REQUEST_START = 0x5;
static const Shortint TNOENC_REQUEST_END = 0x6;
static const Shortint TNOENC_ENC_KEYID = 0x7;
static const Shortint TNOENC_DEC_KEYID = 0x8;
static const Shortint TNOENC_NULL = 0x0;
static const Shortint TNOENC_DES_CFB64 = 0x1;
static const Shortint TNOENC_DES_OFB64 = 0x2;
static const Shortint TNOENC_DES3_CFB64 = 0x3;
static const Shortint TNOENC_DES3_OFB64 = 0x4;
static const Shortint TNOENC_CAST5_40_CFB64 = 0x8;
static const Shortint TNOENC_CAST5_40_OFB64 = 0x9;
static const Shortint TNOENC_CAST128_CFB64 = 0xa;
static const Shortint TNOENC_CAST128_OFB64 = 0xb;
static const Shortint TNOENC_AES_CCM = 0xc;
static const Shortint TNOENC_CFB64_IV = 0x1;
static const Shortint TNOENC_CFB64_IV_OK = 0x2;
static const Shortint TNOENC_CFB64_IV_BAD = 0x3;
static const Shortint TNOENC_OFB64_IV = 0x1;
static const Shortint TNOENC_OFB64_IV_OK = 0x2;
static const Shortint TNOENC_OFB64_IV_BAD = 0x3;

}	/* namespace Idtelnet */
using namespace Idtelnet;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Idtelnet
