//---------------------------------------------------------------------------
#ifndef NNTPModsH
#define NNTPModsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include "OverbyteIcsNntpCli.hpp"
#include "OverbyteIcsWndControl.hpp"
#include "OverbyteIcsWSocket.hpp"
#include "msgmans.h"
#include "global.h"
class TNNTPMod;
//---------------------------------------------------------------------------

class TNNTPThread : public TThread
{
private:
protected:
public:
   TNNTPMod *NNTPMod;
	__fastcall virtual TNNTPThread(bool CreateSuspended);
	__fastcall virtual TNNTPThread(TForm *Owner, const AnsiString &account, bool subsonly, bool catchup);
	__fastcall virtual~TNNTPThread();
	void __fastcall Execute();
};


void __fastcall GetNNTPMail(TForm *Owner, const AnsiString &account,
   bool subsonly, bool catchup);

class TNNTPMod : public TForm
{
__published:	// IDE-managed Components
	TSslNntpCli *NNTP;
	TSslContext *SSLContext;
	void __fastcall NNTPDisplay(TObject *Sender, Pointer MsgBuf, int MsgLen);
	void __fastcall NNTPMessageBegin(TObject *Sender);
	void __fastcall NNTPMessageLine(TObject *Sender);
	void __fastcall NNTPMessageEnd(TObject *Sender);
	void __fastcall NNTPRcvdData(TObject *Sender);
	void __fastcall NNTPRequestDone(TObject *Sender, TNntpRequest RqType,
		  WORD ErrCode);
	void __fastcall NNTPSendData(TObject *Sender);
	void __fastcall NNTPSessionClosed(TObject *Sender, WORD ErrCode);
	void __fastcall NNTPSessionConnected(TObject *Sender, WORD ErrCode);
	void __fastcall NNTPXHdrBegin(TObject *Sender);
	void __fastcall NNTPXHdrEnd(TObject *Sender);
	void __fastcall NNTPXHdrLine(TObject *Sender);
private:	// User declarations
	int  __fastcall SendWindowsMessage();
	void __fastcall OwnerPerform(UINT msg, WPARAM wparam, LPARAM lparam);
	void __fastcall OwnerErrBox(const AnsiString &text, TMsgBoxTypes type, UINT Buttons);
	void __fastcall ShowProgress(const double current, const double total, const AnsiString &article);
	void __fastcall ShowStatus(const AnsiString &msg);
	bool __fastcall SetupProxy();
	int  __fastcall PercentComplete(double next);
	void __fastcall Display(const AnsiString &msg);
	bool __fastcall SubjectMatch(const AnsiString &msgsubject);
	bool __fastcall SubjectMatch(TMsgManager *msg);
	void __fastcall SaveLog();
	void __fastcall RetrieveComplete();
public:		// User declarations
	UINT smMsg;
	WPARAM smWParam;
	LPARAM smLParam;
	TMsgManager *msgman;
	double next, totalarticles;
	AnsiString nntpproxy, newsgroup, account, server, progressMsg, statusMsg;
	int maxloglines, mails, curmsg, lasterror;
	bool subsonly, catchup, working, canceled, connecting, nada, aborted, timeout;
	TStringList *profile, *transcript, *proxy, *subjects, *data, *message;

	__fastcall TNNTPMod(TComponent* Owner);
	__fastcall virtual ~TNNTPMod();
	bool __fastcall GetTheMail();
	//message function
	void __fastcall WMNNTPTimeout(TMessage &Msg);
	void __fastcall WMNNTPCancel(TMessage &Msg);
	// message map
	BEGIN_MESSAGE_MAP
	MESSAGE_HANDLER(WM_NNTPTIMEOUTTIMER, TMessage, WMNNTPTimeout)
	MESSAGE_HANDLER(WM_NNTPCANCEL, TMessage, WMNNTPCancel)
	END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
const AnsiString ConnectionClosed = "Connection closed!";
//extern PACKAGE TNNTPMod *NNTPMod;
extern HANDLE NNTPModHandle;
extern TNNTPThread *NNTPThrd;
extern int NNTPThrdHandle;
//---------------------------------------------------------------------------
#endif
