/*
*  nntphostdlgs.cpp 
*
*  Copyright (C) 2012 Richard Christman 
*
*  This file is part of QuickSilver AAM.
*
*  QuickSilver AAM is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver AAM, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver AAM grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "nntphostdlgs.h"
#include "global.h"
#include "utility.h"
//#include "dbs.h"
//#include "proxydlgs.h"
#include "proxymandlgs.h"
#include "msgmans.h"
#include "help.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//TSMTPHostDlg *SMTPHostDlg;
//---------------------------------------------------------------------------

bool __fastcall AddNNTPHost(TForm *Owner, TStrings *host, TStrings *existing)
{
   if (host->Values["port"].IsEmpty())
	  host->Values["port"] = "119";
   if (host->Values["tls"].IsEmpty())
	  host->Values["tls"] = "none";

   TNNTPHostDlg *hostdlg = new TNNTPHostDlg(Owner, host, existing);
   hostdlg->ShowModal();
   bool ok = hostdlg->ModalResult == mrOk;
   delete hostdlg;
   return ok;
}
//---------------------------------------------------------------------------

bool __fastcall EditNNTPHost(TForm *Owner, TStrings *host, TStrings *existing)
{
   TNNTPHostDlg *hostdlg = new TNNTPHostDlg(Owner, host, existing);
   hostdlg->NNTPLastArticle->Color = clWindow;
   hostdlg->NNTPLastArticle->ReadOnly = false;
   hostdlg->ShowModal();
   bool ok = hostdlg->ModalResult == mrOk;
   delete hostdlg;
   return ok;
}
//---------------------------------------------------------------------------

/*bool __fastcall ManageSingleSMTPServer(TForm *Owner, bool &reloadmessage)
{
   reloadmessage = false;
   TStringList *host = new TStringList();
   TStringList *existing = new TStringList();

   TStringList *message = new TStringList();
   TMsgManager *msg = new TMsgManager(message);
   DB->LoadDefMessage(message);
   AnsiString newserver, server = GetTok(0, msg->GetHeader("Host:"), ':');

   DB->LoadSMTP(server, host);
   if (!host->Count)
   {
	  host->Values["key"] = server;
	  host->Values["host"] = server;
   }

   TSMTPHostDlg *hostdlg = new TSMTPHostDlg(Owner, host, existing);
   hostdlg->Label6->Caption = "Your messages must contain a 'Host' header "
   "with the value from the SMTP Server field below.";
   hostdlg->SMTPKey->Enabled = false;
   hostdlg->SMTPKey->ParentColor = true;
   hostdlg->ProxyBtn->Visible = true;
   hostdlg->ShowModal();
   bool ok = hostdlg->ModalResult == mrOk;
   if (ok)
   {
	  newserver = host->Values["host"];
	  host->Values["key"] = newserver;
	  DB->DelSMTP(server);
	  DB->SaveSMTP(newserver, host);
	  if (newserver != server)
	  {
		 int x = msg->DelHeader("Host:");
		 assert(x >= 0);
		 message->Insert(x, "Host: " + newserver);
		 DB->SaveDefMessage(message);
		 reloadmessage = true;
	  }
   }
   delete hostdlg;

   delete msg;
   delete message;

   delete existing;
   delete host;

   return ok;
}*/
//---------------------------------------------------------------------------

__fastcall TNNTPHostDlg::TNNTPHostDlg(TComponent* Owner)
		: TForm(Owner)
{
}
//---------------------------------------------------------------------------

__fastcall TNNTPHostDlg::TNNTPHostDlg(TComponent* Owner, TStrings *Hostdata,
   TStrings *Existing) : TForm(Owner)
{
   PopupParent = (TForm*)Owner;
   TIniFile *ini = new TIniFile(AppIni());
   AssignFont(Font, ini->ReadString("settings", "dialogfont", OptsDefDialogFont));
   AssignFont(NNTPKey->Font, ini->ReadString("settings", "windowfont",
	  OptsDefWindowFont));
   NNTPServer->Font->Assign(NNTPKey->Font);
   NNTPPort->Font->Assign(NNTPKey->Font);
   NNTPUserID->Font->Assign(NNTPKey->Font);
   NNTPPassword->Font->Assign(NNTPKey->Font);
#ifdef QS2
   expertmode = ini->ReadBool("settings", "expertmode", false);
#else
   expertmode = true;
#endif
   ProxyBtn->Caption = expertmode ? "&Proxies" : "&Proxy";
   delete ini;

   hostdata = Hostdata;
   existing = Existing;
   NNTPKey->Text = hostdata->Values["key"];
   NNTPServer->Text = hostdata->Values["host"];
   NNTPPort->Text = hostdata->Values["port"];
   if (NNTPPort->Text.IsEmpty())
      NNTPPort->Text = "119";
   NNTPLastArticle->Text = hostdata->Values["lastarticle"];
   NNTPAuth->Checked = hostdata->Values["auth"] == "1";
   NNTPUserID->Text = hostdata->Values["userid"];
   NNTPPassword->Text = hostdata->Values["password"];
   NNTPTls->ItemIndex = NNTPTls->Items->IndexOf(hostdata->Values["tls"]);
   if ((NNTPTls->ItemIndex < 0))
	  NNTPTls->ItemIndex = 0;

   NNTPAuthClick(NULL);
}
//---------------------------------------------------------------------------

void __fastcall TNNTPHostDlg::FormCloseQuery(TObject *Sender,
	  bool &CanClose)
{
   bool mod = Modified();
   if (mod)
   {
	  if (ModalResult == mrCancel)
	  {
		 switch (MsgBox(this,
		   "Your host info is modified. Save your changes? ",
			MT_CONFIRM, MB_YESNOCANCEL))
		 {
			case IDCANCEL:
			   CanClose = false;
			case IDNO:
			   return;
		 }
		 ModalResult = mrOk;
	  }

	  if (NNTPServer->Text.Pos(":") > 0)
	  {
		 MsgBox(this,
			"Sorry, colons ':' not allowed in the Server field. If you   \n"
			"are attempting to enter an IPv6 ip address, I'm sorry,   \n"
			"QSA doesn't currently support IPv6. It's coming, but   \n"
			"I can't give you a date. Hopefully sometime   \n"
			"during 2012.",
			MT_INFO, MB_OK);
		 ActiveControl = NNTPServer;
		 CanClose = false;
		 return;
	  }

	  /*if (NNTPKey->Text.Pos(":") > 0)
	  {
		 MsgBox(this,
			"Sorry, colons ':' not allowed in Name and Server fields.   ",
			MT_INFO, MB_OK);
		 ActiveControl = NNTPKey;
		 CanClose = false;
		 return;
	  }*/

	  if (NNTPKey->Text.IsEmpty() && !NNTPServer->Text.IsEmpty())
		 NNTPKey->Text = NNTPServer->Text;

	  if (NNTPPort->Text.IsEmpty())
	  {
		 NNTPPort->Text = "119";
		 NNTPTls->ItemIndex = 0;
	  }

	  if ((NNTPPort->Text == "563") && NNTPTls->Text != "TLS")
	  {
		 if (MsgBox(this,
			"You have set the NNTP port to 563 but TLS/SSL is not set to TLS.  \n"
			"This probably won't work. Shall I change it to TLS?",
			MT_CONFIRM, MB_YESNO) == IDYES)
		 {
			NNTPTls->ItemIndex = 1;
		 }
		 else
		 {
			MsgBox(this,
			   "Ok, but if the connection doesn't work, this is the first   \n"
			   "thing you need to look at.",
			   MT_INFO, MB_OK);
		 }
	  }

	  if (NNTPServer->Text.IsEmpty())
	  {
		 MsgBox(this,
			"Problem! You have to provide an NNTP server to retrieve  your   \n"
			"NNTP mail. If you're not sure what it is, check your regular   \n"
			"newsreader program.",
			 MT_INFO, MB_OK);
		 CanClose = false;
		 return;
	  }

	  if (NNTPAuth->Checked &&
		 (NNTPUserID->Text.IsEmpty() || NNTPPassword->Text.IsEmpty()))
	  {
		 MsgBox(this,
			"Problem! You have NNTP Authentication enabled. That also \n"
			"requires you provide User ID and Password.",
			 MT_INFO, MB_OK);
		 CanClose = false;
		 return;
	  }

	  if (existing->IndexOf(NNTPKey->Text) >= 0)
	  {
		 MsgBox(this,
			"Sorry, the name '"+NNTPKey->Text+"' value already exists!   \n"
			"It must be unique!   ",
			 MT_INFO, MB_OK);
		 CanClose = false;
		 return;
	  }

	  hostdata->Values["key"] = NNTPKey->Text;
	  hostdata->Values["host"] = NNTPServer->Text;
	  hostdata->Values["port"] = NNTPPort->Text;
	  hostdata->Values["lastarticle"] = NNTPLastArticle->Text;
	  hostdata->Values["auth"] = NNTPAuth->Checked ? "1" : "0";
	  hostdata->Values["userid"] = NNTPUserID->Text;
	  hostdata->Values["password"] = NNTPPassword->Text;
	  hostdata->Values["tls"] = NNTPTls->Text;
   }

   if (!mod && ModalResult == mrOk)
	  ModalResult = mrCancel;
}
//---------------------------------------------------------------------------

bool __fastcall TNNTPHostDlg::Modified()
{
   return NNTPKey->Text != hostdata->Values["key"] ||
   NNTPServer->Text != hostdata->Values["host"] ||
   NNTPPort->Text != hostdata->Values["port"] ||
   NNTPLastArticle->Text != hostdata->Values["lastarticle"] ||
   NNTPAuth->Checked != (hostdata->Values["auth"] == "1") ||
   NNTPUserID->Text != hostdata->Values["userid"] ||
   NNTPPassword->Text != hostdata->Values["password"] ||
   NNTPTls->Text != hostdata->Values["tls"];
}
//---------------------------------------------------------------------------

void __fastcall TNNTPHostDlg::NNTPAuthClick(TObject *Sender)
{
   if (NNTPAuth->Checked)
   {
	  NNTPUserID->Enabled = true;
	  NNTPUserID->Color = clWindow;
	  NNTPPassword->Enabled = true;
	  NNTPPassword->Color = clWindow;
	  HideBox->Enabled = true;
	  Label2->Enabled = true;
	  Label5->Enabled = true;
   }
   else
   {
	  NNTPUserID->Enabled = false;
	  NNTPUserID->ParentColor = true;
	  NNTPPassword->Enabled = false;
	  NNTPPassword->ParentColor = true;
	  HideBox->Enabled = false;
	  HideBox->Checked = true;
	  Label2->Enabled = false;
	  Label5->Enabled = false;
   }
}
//---------------------------------------------------------------------------

void __fastcall TNNTPHostDlg::NNTPServerExit(TObject *Sender)
{
   if (NNTPKey->Text.IsEmpty())
	  NNTPKey->Text = NNTPServer->Text;
}
//---------------------------------------------------------------------------

void __fastcall TNNTPHostDlg::ProxyBtnClick(TObject *Sender)
{
   ManageProxies(this);
}
//---------------------------------------------------------------------------

void __fastcall TNNTPHostDlg::HideBoxClick(TObject *Sender)
{
  if (!HideBox->Checked)
  {
	NNTPPassword->PasswordChar = '\0';
  }
  else
  {
	NNTPPassword->PasswordChar = '*';
  }
}
//---------------------------------------------------------------------------

void __fastcall TNNTPHostDlg::NNTPPortExit(TObject *Sender)
{
   if (NNTPPort->Text == "563")// || NNTPPort->Text == "submission") {
	  NNTPTls->ItemIndex = 1;
   //}
   //if (NNTPPort->Text == "465" || NNTPPort->Text == "smtps") {
   //	  NNTPTls->ItemIndex = 2;
   //}
}
//---------------------------------------------------------------------------

void __fastcall TNNTPHostDlg::NNTPPortChange(TObject *Sender)
{
   if (NNTPPort->Text == "563")// || NNTPPort->Text == "submission")
	   NNTPTls->ItemIndex = 1;
   //else
   //if (NNTPPort->Text == "465" || NNTPPort->Text == "smtps")
   //	   NNTPTls->ItemIndex = 2;
   else
	   NNTPTls->ItemIndex = 0;
}
//---------------------------------------------------------------------------

void __fastcall TNNTPHostDlg::NNTPServerChange(TObject *Sender)
{
   if (!NNTPKey->Enabled)
	  NNTPKey->Text = NNTPServer->Text;
}
//---------------------------------------------------------------------------

void __fastcall TNNTPHostDlg::HelpBtnClick(TObject *Sender)
{
   DisplayHtmlHelpTopic(this, "::/html/nntphost.htm>newshelp");
}
//---------------------------------------------------------------------------

