/*
*  paramsdlgs.cpp 
*
*  Copyright (C) 2012 Richard Christman 
*
*  This file is part of QuickSilver AAM.
*
*  QuickSilver AAM is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver AAM, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver AAM grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "paramsdlgs.h"
#include "global.h"
#include "utility.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TParamsDlg *ParamsDlg;
//---------------------------------------------------------------------------

bool __fastcall EditProgramParameters(TForm *Owner)
{
   ParamsDlg = new TParamsDlg(Owner);
   ParamsDlg->ShowModal();
   bool ok = ParamsDlg->ModalResult == mrOk && ParamsDlg->Editor->Modified;
   delete ParamsDlg;
   return ok;
}

//---------------------------------------------------------------------------

__fastcall TParamsDlg::TParamsDlg(TComponent* Owner)
        : TForm(Owner)
{
   Editor->Clear();
   if (FileExists(AppIni()))
      Editor->Lines->LoadFromFile(AppIni());
   Editor->Modified = false;
}
//---------------------------------------------------------------------------
#pragma argsused
void __fastcall TParamsDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (Editor->Modified)
   {
      if (ModalResult == mrCancel)
      {
         switch (MsgBox(this,
            "Your parameters are modified. Save your changes?   ",
            MT_CONFIRM, MB_YESNOCANCEL))
         {
            case IDCANCEL: CanClose  = false;
            case IDNO: return;
         }
         ModalResult = mrOk;
      }
      Editor->Lines->SaveToFile(AppIni());
   }
}
//---------------------------------------------------------------------------
