/*
*  sigfaileddlgs.cpp
*
*  Copyright (C) 2012 Richard Christman
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by the
*  Free Software Foundation; either version 3 of the License, or (at your
*  option) any later version.
*
*  This program is distributed in the hope that it will be useful, but
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*  for more details.
*
*  You should have received a copy of the GNU General Public License along
*  with this program; if not, see <http://www.gnu.org/licenses>.
*
*  Additional permission under GNU GPL version 3 section 7
*
*  If you modify QuickSilver Lite, or any covered work, by linking or
*  combining it with CodeGear VCL (or a modified version of that library),
*  containing parts covered by the terms of CodeGear's license, the licensors
*  of QuickSilver Lite grant you additional permission to convey the
*  resulting work.
*
*/

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <inifiles.hpp>

#include "sigfaileddlgs.h"
#include "global.h"
#include "utility.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSigFailedDlg *SigFailedDlg;
//---------------------------------------------------------------------------

void __fastcall CheckShowNymserverSignatureFailed(TForm *Owner, TStrings *Sig, const AnsiString &nymhdr)
{
   //AnsiString addr = GetEAddress(nymhdr), domain = GetDomain(addr), sig = Sig->Text;
   //if (domain.IsEmpty()) domain = "-------";

   bool goodsig = Sig->Text.LowerCase().Pos("good signature "); //, gooddom = sig.Pos("@"+domain);
   //if (goodsig)
   //{
   //	   if (!gooddom)
   //		  gooddom = domain == "is-not-my.name" && sig.Pos("@mixnym.net");
   //	   if (!gooddom)
   //		  gooddom = domain == "mixmin.net" && sig.Pos("@is-not-my.name");
   //}
   if (Sig->Count == 0)
   {
	  MsgBox(Owner,
		 "This message should be PGP signed by the nymserver, BUT   \n"
		 "IT IS NOT! This message could be dangerous. Take care!",
		  MT_WARN, MB_OK);
	  return;
	  //TSigFailedDlg *sigdlg = new TSigFailedDlg(Owner);
	  //sigdlg->Label2->Caption = "Message is NOT SIGNED by the nymserver!";
	  //sigdlg->ShowModal();
	  //delete sigdlg;
	  //return;
   }
   if (!goodsig) // && gooddom)
   {
	  TSigFailedDlg *sigdlg = new TSigFailedDlg(Owner);
	  sigdlg->SigViewer->Lines->AddStrings(Sig);
	//sigdlg->Label2->Caption = "Nymserver signature FAILED verification!";
	  sigdlg->ShowModal();
	  delete sigdlg;
	  return;
   }
   //if (goodsig && !gooddom)
   //{
   //	  TSigFailedDlg *sigdlg = new TSigFailedDlg(Owner);
   //	  sigdlg->SigViewer->Lines->AddStrings(Sig);
   //	  sigdlg->Label2->Caption = "GOOD signature, but NOT BY THE NYMSERVER!";
   //	  sigdlg->ShowModal();
   //	  delete sigdlg;
   //	  return;
   //}
   //if (!goodsig && !gooddom)
   //{
   //	  TSigFailedDlg *sigdlg = new TSigFailedDlg(Owner);
   //	  sigdlg->SigViewer->Lines->AddStrings(Sig);
   //	  sigdlg->Label2->Caption = "FAILED signature and NOT BY THE NYMSERVER!";
   //	  sigdlg->ShowModal();
   //	  delete sigdlg;
   //	  return;
   //}
}
//---------------------------------------------------------------------------

__fastcall TSigFailedDlg::TSigFailedDlg(TComponent* Owner)
	: TForm(Owner)
{
   SigViewer->Clear();
   TIniFile *ini = new TIniFile(AppIni());
   AssignFont(Font, ini->ReadString("settings", "dialogfont", OptsDefDialogFont));
   AssignFont(SigViewer->Font, ini->ReadString("settings", "editorfont", OptsDefEditorFont));
   delete ini;
}
//---------------------------------------------------------------------------

void __fastcall TSigFailedDlg::PopupMenu1Popup(TObject *Sender)
{
   Copy1->Enabled = SigViewer->SelLength > 0;
   Selectall1->Enabled = SigViewer->Text.Length() > 0;
}
//---------------------------------------------------------------------------
