/*
*  utility.cpp 
*
*  Copyright (C) 2012 Richard Christman 
*
*  This file is part of QuickSilver AAM.
*
*  QuickSilver AAM is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver AAM, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver AAM grant you additional permission to convey the
*  resulting work.
*
*/

//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
#include <comctrls.hpp>

#include "utility.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------

AnsiString __fastcall DecodeQuotedPrintable(const AnsiString &text)
{
   int j, i = 1;
   AnsiString decoded, goods = "0123456789ABCDEF"; //abcdef";
   while (i <= text.Length())
   {
	  j = i;
	  while (i <= text.Length() && text[i] != '=')
		 i++;
	  decoded += text.SubString(j, i - j);
	  if (i >= text.Length())
		 break;
	  if (text[i + 1] != '\r' && text[i + 1] != '\n')
	  {
		 try
		 {
			AnsiString chrs = text.SubString(i + 1, 2);
			if (goods.Pos(chrs[1]) && goods.Pos(chrs[2]))
			   decoded += AnsiChar(StrToInt("$"+chrs));
			else
			   decoded += text.SubString(i, 3);
		 }
		 catch(EConvertError &e)
		 {
		 }
	  }
	  i += 3;
   }
   return decoded;
}
//---------------------------------------------------------------------------

/*AnsiString __fastcall DecodeQuotedPrintable(const AnsiString &text)
{
   int j, i = 1;
   AnsiString decoded, goods = "0123456789ABCDEF"; //abcdef";
   while (i <= text.Length())
   {
	  j = i;
	  while (i <= text.Length() && text[i] != '=')
		 i++;
	  decoded += text.SubString(j, i - j);
	  if (i >= text.Length())
		 break;
	  if (text[i + 1] != '\r' && text[i + 1] != '\n')
	  {
		 try
		 {
			AnsiString chrs = text.SubString(i + 1, 2);
			if (goods.Pos(chrs[1]) && goods.Pos(chrs[2]))
			   decoded += AnsiChar(StrToInt("$"+chrs));
			else
			   decoded += text.SubString(i, 3);

		 }
		 catch(EConvertError &e)
		 {
		 }
	  }
	  i += 3;
   }
   return decoded;
}*/
//---------------------------------------------------------------------------

/*AnsiString __fastcall DecodeQuotedPrintable(const AnsiString &text)
{
   int j, i = 1;
   AnsiString decoded, goods = "0123456789ABCDEFabcdef";
   while (i <= text.Length())
   {
	  j = i;
	  while (i <= text.Length() && text[i] != '=')
		 i++;
	  decoded += text.SubString(j, i - j);
	  if (i >= text.Length())
		 break;
	  if (text[i + 1] != '\r' && text[i + 1] != '\n')
	  {
		 //try
		 //{
			AnsiString chrs = text.SubString(i + 1, 2);
			if (goods.Pos(chrs[1]) && goods.Pos(chrs[2]))
			   decoded += AnsiChar(StrToInt("$"+chrs));
			else
			   decoded += text.SubString(i, 3);
		 //}
		 //catch(EConvertError &e)
		 //{
		 //}
	  }
	  i += 3;
   }
   return decoded;
}*/
/*AnsiString __fastcall DecodeQuotedPrintable(const AnsiString &text)
{
   int j, i = 1;
   AnsiString decoded;
   while (i <= text.Length())
   {
	  j = i;
	  while (i <= text.Length() && text[i] != '=')
		 i++;
	  decoded += text.SubString(j, i - j);
	  if (i >= text.Length())
		 break;
	  if (text[i + 1] != '\r' && text[i + 1] != '\n')
		 decoded += AnsiChar(StrToInt("$"+text.SubString(i + 1, 2)));
	  i += 3;
   }
   return decoded;
}*/
//---------------------------------------------------------------------------

AnsiString __fastcall withcommas(int num)
{
   AnsiString numstr = IntToStr(num);
   if (numstr.Length() > 3)
	  numstr.Insert(",", numstr.Length() - 2);
   return numstr;
}
//---------------------------------------------------------------------------

/*void __fastcall LoadWindowPosition(TForm *win, const AnsiString winname,
   TListView *listview, TPanel *Panel, TRichEdit *PreviewPane,
   TIniFile *ini)
{
   //int L = win->Left, T = win->Top, W = win->Width, H = win->Height;
   AnsiString wincoords = ini->ReadString("windows", winname, "");
	//IntToStr(L) + "," + IntToStr(T) + "," + IntToStr(W) + "," + IntToStr(H));

   int x = -1;
   win->Left   = GetTok(++x, wincoords, ',').ToIntDef(win->Left);
   win->Top    = GetTok(++x, wincoords, ',').ToIntDef(win->Top);
   win->Width  = GetTok(++x, wincoords, ',').ToIntDef(win->Width);
   win->Height = GetTok(++x, wincoords, ',').ToIntDef(win->Height);
   win->WindowState = (TWindowState)GetTok(++x, wincoords, ',').ToIntDef(wsNormal);

   for (int l = 0; l < listview->Columns->Count; l++)
   {
	  int width = GetTok(++x, wincoords, ',').ToIntDef(-1);
	  if (width >= 0)
		 listview->Column[l]->Width = width;
   }

   Panel->Width = GetTok(++x, wincoords, ',').ToIntDef(Panel->Width);
   listview->Height = GetTok(++x, wincoords, ',').ToIntDef(listview->Height);

}*/
//---------------------------------------------------------------------------

/*void __fastcall SaveWindowPosition(TForm *win, const AnsiString winname,
   TListView *listview, TPanel *Panel, TRichEdit *PreviewPane,
   TIniFile *ini)
{
   if (win->WindowState == wsNormal)
   {
	  AnsiString wincoords =
		 IntToStr(win->Left) +
		 "," + IntToStr(win->Top) +
		 "," + IntToStr(win->Width) +
		 "," + IntToStr(win->Height) +
		 "," + IntToStr(win->WindowState);
	  for (int l = 0; l < listview->Columns->Count; l++)
		 wincoords += "," + IntToStr(listview->Column[l]->Width);
	  wincoords +=
		 "," + IntToStr(Panel->Width) +
		 "," + IntToStr(listview->Height);
	  ini->WriteString("windows", winname, wincoords);
   }
}*/
//---------------------------------------------------------------------------

AnsiString __fastcall SetTok(int pos, AnsiString text, char divider, const AnsiString &value)
{
   bool dellast = false;
   int lasti = -1, x = -1;
   if (text.Length() && text[text.Length()] != divider)
   {
	  text += divider;
	  dellast = true;
   }
   for (int i = 1; i <= text.Length(); i++)
   {
	  if (text[i] == divider)
	  {
		 x++;
		 if (x == pos)
		 {
			text.Delete(lasti + 1, i - (lasti + 1));
			text.Insert(value, lasti + 1);
			break;
		 }
		 lasti = i;
	  }
   }
   if (dellast)
	  text.Delete(text.Length(), 1);
   return text;
}
//---------------------------------------------------------------------------

AnsiString __fastcall GetTok(int pos, const AnsiString &text, char div, const AnsiString &def)
{
   AnsiString token;
   int start = 0, tok = 0, len = text.Length() + 1;

   for (int ch = 1; ch <= len; ch++)
   {
      bool isdiv = ch == len || text[ch] == div;
      if (isdiv)
         tok++;

      if (tok > pos)
      {
		 token = text.SubString(start + 1, ch - (start + 1));
         break;
      }

	  if (isdiv)
		 start = ch;
   }

   return token.IsEmpty() ? def : token;
}
//---------------------------------------------------------------------------

AnsiString __fastcall GetTokSpc(int pos, const AnsiString &fromStr)
{
   AnsiString from = fromStr.Trim();
   int p = from.Pos(" ");
   if (p == 0)
	  p = from.Length();
   if (pos > 0)
	  return GetTokSpc(pos - 1, from.SubString(p, 256).Trim());

   return from.Trim().SubString(1, p).Trim();
}
//---------------------------------------------------------------------------

/*AnsiString __fastcall GetSystemPath(int Folder)
{
   AnsiString path;
   PItemIDList PIDL;
   IMalloc AMalloc;
   char *Path = new char[MAX_PATH];
   SHGetSpecialFolderLocation(Application->Handle, Folder, PIDL);
   if (SHGetPathFromIDList(PIDL, Path))
	  path = Path;
   SHGetMalloc(AMalloc);
   AMalloc.Free(PIDL);
   StrDispose(Path);
}

Now you can call this function with different parameters. For example:
CSIDL_DESKTOP for WINDOWS\Desktop
CSIDL_DESKTOPDIRECTORY for WINDOWS\Desktop
CSIDL_FONTS for WINDOWS\FONTS
CSIDL_NETHOOD for WINDOWS\NetHood
CSIDL_PERSONAL for X:\My Documents
CSIDL_PROGRAMS for WINDOWS\StartMenu\Programs
CSIDL_RECENT for WINDOWS\Recent
CSIDL_SENDTO for WINDOWS\SendTo
CSIDL_STARTMENU for WINDOWS\Start Menu
CSIDL_STARTUP for WINDOWS\Start Menu\Programs\StartUp
CSIDL_TEMPLATES for WINDOWS\ShellNew
*/
//---------------------------------------------------------------------------

AnsiString __fastcall GetLastErrorStr(DWORD *errnum)
{
   DWORD result = GetLastError();
   if (errnum) *errnum = result;
   LPVOID lpMsgBuf;
   FormatMessage(
	  FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
	  NULL,
	  result,
      MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
     (LPTSTR) &lpMsgBuf,
      0,
      NULL
   );
   return AnsiString((char*)lpMsgBuf);
}
//---------------------------------------------------------------------------

void __fastcall SnoozeT(int millisecs)
{
   LARGE_INTEGER liDueTime;
   liDueTime.QuadPart = -(1000000 * millisecs / 100);
   HANDLE hTimer = CreateWaitableTimer(NULL, true, NULL);
   SetWaitableTimer(hTimer, &liDueTime, 0, NULL, NULL, 0);
   WaitForMultipleObjects(1, &hTimer, false, INFINITE);
   CloseHandle(hTimer);
}
//---------------------------------------------------------------------------

void __fastcall Snooze(DWORD millisecs)
{
   DWORD ticks = GetTickCount();
   while (true)
   {
      Application->ProcessMessages();
	  Sleep(0);
      if (GetTickCount() >= (ticks + millisecs) || Application->Terminated)
         break;
   }
}
//---------------------------------------------------------------------------

AnsiString __fastcall DropQuotes(AnsiString &str)
{
   while (str.Length() && str[str.Length()] == '\"')
      str.Delete(str.Length(), 1);
   while (str.Length() && str[1] == '\"')
      str.Delete(1, 1);
   return str;
}
//---------------------------------------------------------------------------

AnsiString __fastcall DropCrLf(AnsiString line)
{
   AnsiString crlf = "\r\n";
   while (line.Length() && crlf.Pos(line[line.Length()]))
	  line.Delete(line.Length(), 1);
   return line;
}
//---------------------------------------------------------------------------

void __fastcall look(TStrings *lines, const AnsiString &title)
{
   TForm *looker = new TForm((void*)NULL);
   looker->Caption = title;
   looker->Position = poScreenCenter;
   looker->Width = 700;
   looker->Height = 800;
   looker->BorderStyle = bsSizeable;
   looker->BorderIcons = TBorderIcons() << biSystemMenu;
   TRichEdit *ed = new TRichEdit(looker);
   ed->Parent = looker;
   ed->Align = alClient;
   ed->Font->Name = "Courier New";
   ed->Font->Size = 10;
   ed->PlainText = true;
   ed->ScrollBars = ssBoth;
   ed->WordWrap = false;
   if (lines)
	  ed->SetTextBuf(lines->Text.c_str());
   //if (title != "")
   //   ed->Lines->Add(title);

   looker->ShowModal();
   delete ed;
   delete looker;
}
//---------------------------------------------------------------------------

void __fastcall LoadWindowPosition(TForm *win, const AnsiString winname, TIniFile *ini)
{
   int L = win->Left, T = win->Top, W = win->Width, H = win->Height;
   AnsiString wincoords = ini->ReadString("settings", winname,
	  IntToStr(L) + "," + IntToStr(T) + "," + IntToStr(W) + "," + IntToStr(H));

   win->Left   = GetTok(0, wincoords, ',').ToIntDef(L);
   win->Top    = GetTok(1, wincoords, ',').ToIntDef(T);
   win->Width  = GetTok(2, wincoords, ',').ToIntDef(W);
   win->Height = GetTok(3, wincoords, ',').ToIntDef(H);
   win->WindowState = (TWindowState)GetTok(4, wincoords, ',').ToIntDef(wsNormal);
}
//---------------------------------------------------------------------------

void __fastcall LoadWindowPosition(TForm *win, const AnsiString winname,
   TListView *listview, TIniFile *ini)
{
   int L = win->Left, T = win->Top, W = win->Width, H = win->Height;
   AnsiString wincoords = ini->ReadString("settings", winname,
	  IntToStr(L) + "," + IntToStr(T) + "," + IntToStr(W) + "," + IntToStr(H));

   win->Left   = GetTok(0, wincoords, ',').ToIntDef(L);
   win->Top    = GetTok(1, wincoords, ',').ToIntDef(T);
   win->Width  = GetTok(2, wincoords, ',').ToIntDef(W);
   win->Height = GetTok(3, wincoords, ',').ToIntDef(H);
   win->WindowState = (TWindowState)GetTok(4, wincoords, ',').ToIntDef(wsNormal);

   listview->Height = GetTok(5, wincoords, ',').ToIntDef(listview->Height);
   for (int l = 0; l < listview->Columns->Count; l++)
   {
	  int width = GetTok(l + 6, wincoords, ',').ToIntDef(-1);
	  if (width >= 0)
		 listview->Column[l]->Width = width;
   }
}
//---------------------------------------------------------------------------

void __fastcall SaveWindowPosition(TForm *win, const AnsiString winname, TIniFile *ini)
{
   if (win->WindowState == wsNormal)
   {
	  ini->WriteString("settings", winname, IntToStr(win->Left) +
		 "," + IntToStr(win->Top) +
		 "," + IntToStr(win->Width) +
		 "," + IntToStr(win->Height) +
		 "," + IntToStr(win->WindowState));
   }
}
//---------------------------------------------------------------------------

void __fastcall SaveWindowPosition(TForm *win, const AnsiString winname,
   TListView *listview, TIniFile *ini)
{
   if (win->WindowState == wsNormal)
   {
	  AnsiString colwidths = IntToStr(listview->Height);
	  for (int l = 0; l < listview->Columns->Count; l++)
		 colwidths += "," + IntToStr(listview->Column[l]->Width);
	  colwidths += "," + IntToStr(listview->Height);
	  ini->WriteString("settings", winname, IntToStr(win->Left) +
		 "," + IntToStr(win->Top) +
		 "," + IntToStr(win->Width) +
		 "," + IntToStr(win->Height) +
		 "," + IntToStr(win->WindowState) +
		 "," + colwidths);
   }
}
//---------------------------------------------------------------------------

void __fastcall SetEditRect(TCustomMemo *Editor)
{
   int x1 = 7, y1 = 7, x2 = 5, y2 = 0;
   //x1 = 10; //GetTok(0, seteditrectspec, ',').ToIntDef(10);
   //y1 = 0; //GetTok(1, seteditrectspec, ',').ToIntDef(0);
   //x2 = 5; //GetTok(2, seteditrectspec, ',').ToIntDef(0);
   //y2 = 0; //GetTok(3, seteditrectspec, ',').ToIntDef(0);
   TRect Rct = Rect(x1, y1, Editor->ClientWidth-x2, Editor->ClientHeight-y2);
   Editor->Perform(EM_SETRECT,0,long(&Rct));
}
//---------------------------------------------------------------------------

HINSTANCE __fastcall ExploreFolder(const AnsiString &strFolder)
{
   HINSTANCE hInst;
   hInst = Exec32("explorer.exe "+strFolder,SW_SHOWNORMAL);
   return hInst;
}
//---------------------------------------------------------------------------

HANDLE __fastcall Exec32(const AnsiString &strCmdLine, const WORD ShowCmd)
{
//sm(strCmdLine);
   STARTUPINFO siStartInfo; 					// Set up members of STARTUPINFO structure
   PROCESS_INFORMATION piProcInfo;
   siStartInfo.cb = sizeof(STARTUPINFO);
   siStartInfo.lpReserved = NULL;
   siStartInfo.lpDesktop = NULL;
   siStartInfo.lpTitle = NULL;
   siStartInfo.wShowWindow = ShowCmd;
   siStartInfo.lpReserved2 = NULL;
   siStartInfo.cbReserved2 = 0;
   siStartInfo.dwFlags = STARTF_USESHOWWINDOW;
   CreateProcess(NULL,   	  // Create the child process
      strCmdLine.c_str(),
      NULL, 	                  // process security attributes
      NULL, 			  // primary thread security attributes
      0, 			  // handles are inherited
      0, 			  // creation flags
      NULL, 			  // use parent's environment
      NULL, 			  // use parent's current directory
     &siStartInfo, 		  // STARTUPINFO pointer
     &piProcInfo
   ); 				  // receives PROCESS_INFORMATION
   return piProcInfo.hProcess;
}
//---------------------------------------------------------------------------

AnsiString __fastcall ScrubCap(AnsiString cap)
{
   int pos = cap.Pos("&");
   if (pos > 0) cap.Delete(pos, 1);
   return cap;
}
//---------------------------------------------------------------------------

AnsiString __fastcall ReadString(TStrings *config, const AnsiString &name, const AnsiString &defvalue)
{
   AnsiString value = config->Values[name];
   if (value.IsEmpty())
      value = defvalue;
   return value;
}
//---------------------------------------------------------------------------

int __fastcall ReadInteger(TStrings *config, const AnsiString &name, int defvalue)
{
   return config->Values[name].ToIntDef(defvalue);
}
//---------------------------------------------------------------------------

bool __fastcall ReadBool(TStrings *config, const AnsiString &name, bool defvalue)
{
   AnsiString value = config->Values[name];
   return value.IsEmpty() ? defvalue : value == "1";
}
//---------------------------------------------------------------------------

void __fastcall GetUnwrappedText(TCustomMemo *Editor, TStrings *ToStrings)
{
   int len = Editor->Perform(WM_GETTEXTLENGTH,0,0);
   if (len)
   {
      char *buf = new char[len+1];
      Richedit::TEXTRANGE trange = {{0,len}, buf};
      Editor->Perform(EM_GETTEXTRANGE,0,(LPARAM)&trange);
      ToStrings->SetText(buf);
      delete buf;
   }
}
//---------------------------------------------------------------------------

void __fastcall TrimNullsBefore(TStrings *text)
{
   while (text->Count && text->Strings[0].Trim().IsEmpty())
      text->Delete(0);
}
//---------------------------------------------------------------------------

void __fastcall TrimNullsAfter(TStrings *text)
{
   while (text->Count && text->Strings[text->Count - 1].Trim().IsEmpty())
      text->Delete(text->Count - 1);
}
//---------------------------------------------------------------------------

void __fastcall TrimNulls(TStrings *text)
{
   TrimNullsBefore(text);
   TrimNullsAfter(text);
}
//---------------------------------------------------------------------------
TDateTime __fastcall FileDateTime(const AnsiString FileName)
{
  return (FileDateToDateTime(FileAge(FileName)));
}

//---------------------------------------------------------------------------
// MsgBox 
//---------------------------------------------------------------------------

TPoint __fastcall GetCursorPosMidButton(TForm *dlg)
{
   TPoint cli, scr; //cli(0, 0), scr(0, 0);
   for (int i = 0; i < dlg->ControlCount; i++)
   {
      TButton *btn = dynamic_cast<TButton*>(dlg->Controls[i]);
      if (btn)
      {
         //if (btn->Caption == "OK" || btn->Caption == "Yes")
         //{
            cli.x = btn->Left + (btn->Width / 2);
            cli.y = btn->Top + (btn->Height / 2);
            scr = dlg->ClientToScreen(cli);
            break;
         //}
	  }
   }
   return scr;
}

int __fastcall MsgDlg(TForm *Owner, const AnsiString &Msg, TMsgDlgType DlgType,
  TMsgDlgButtons Buttons)
{
   int result;

   TForm *msgdlg = CreateMessageDialog(Msg, DlgType, Buttons);
   assert(msgdlg != NULL);
   try
   {
      if (Owner)
      {
         msgdlg->PopupParent = Owner;
         msgdlg->Top = Owner->Top+((Owner->Height-msgdlg->Height)/2);
         msgdlg->Left = Owner->Left+((Owner->Width-msgdlg->Width)/2);
      }
   }
   catch(...)
   {
   }

   TPoint pos = GetCursorPosMidButton(msgdlg);
   SetCursorPos(pos.x, pos.y);
   result = msgdlg->ShowModal();
   delete msgdlg;

   return result;
}

int __fastcall MsgBox(TForm *Owner, const AnsiString &Text, TMsgBoxTypes MsgType, UINT Flags)
{
   TMsgDlgButtons buttons;
 //if ((Flags & MB_YESALLNOALLCANCEL = MB_YESALLNOALLCANCEL) buttons << mbYesAllNoAllCancel; else
   if ((Flags & MB_YESNOCANCEL) == MB_YESNOCANCEL) buttons << mbYes << mbNo << mbCancel; else
   if ((Flags & MB_YESNO) == MB_YESNO) buttons << mbYes << mbNo; else
   if ((Flags & MB_OKCANCEL) == MB_OKCANCEL) buttons << mbOK << mbCancel; else
   if ((Flags & MB_OK) == MB_OK) buttons << mbOK;

   AnsiString text = Text.TrimRight() + "     ";
   switch (MsgType)
   {
      case MT_WARN: return MsgDlg(Owner, text, mtWarning, buttons);
      case MT_ERROR: return MsgDlg(Owner, text, mtError, buttons);
      case MT_INFO: return MsgDlg(Owner, text, mtInformation, buttons);
      case MT_CONFIRM: return MsgDlg(Owner, text, mtConfirmation, buttons);
   }

   return MsgDlg(Owner, text, mtCustom, buttons);
}

//---------------------------------------------------------------------------
// End Msgbox
//---------------------------------------------------------------------------

bool __fastcall ClearDirectory(const AnsiString &directory)
{
   TStringList *names = new TStringList();
   GetFileNames(names, directory + "*.*");

   for (int i = 0; i < names->Count; i++)
   {
      int x = 0;
      while (x < 8 && !DeleteFile(names->Strings[i]))
      {
         x++;
      }
   }

   Snooze(100);
   names->Clear();
   GetFileNames(names, directory + "*.*");
   bool ok = names->Count == 0;

   delete names;
   return ok;
}
//---------------------------------------------------------------------------

int __fastcall GetFileNames(TStrings *names, const AnsiString &pathname,
   int attrib)
{
   if (names)
      names->Clear();
   TSearchRec sr;
   TStringList *Names = new TStringList();
   int done = FindFirst(pathname, attrib, sr);
   while (!done)
   {
      if (sr.Name != "." && sr.Name != "..")
         Names->Add(ExtractFilePath(pathname) + sr.Name);
      done = FindNext(sr);
   }
   if (names) names->Text = Names->Text;
   int count = Names->Count;
   delete Names;
   FindClose(sr);
   return count;
}
//---------------------------------------------------------------------------

AnsiString __fastcall GetEAddress(const AnsiString &fromline)
{
   int f, l, at;
   AnsiString addr;
   //char Terms[7] = { ' ', ',', '<', '>', '=', 10, 13 };
   AnsiString terms = " ;<,>=\n\r";

   at = fromline.Pos("@");
   if (at)
   {
	  f = at; l = at;
	  while (f > 1 && !terms.Pos(fromline[f - 1]))
		 f--;
	  while (l <= fromline.Length() && !terms.Pos(fromline[l]))
		 l++;
	  addr = fromline.SubString(f, l - f);
   }

   return addr.Trim();
}
//---------------------------------------------------------------------------

/*AnsiString __fastcall GetEAddress(const AnsiString &fromline)
{
   char *at;
   UINT f,l;
   AnsiString addr;
   char Terms[7] = { ' ', ',', '<', '>', '=', 10, 13 };

   char *tmp = new char[fromline.Length() + 1];
   strcpy(tmp, fromline.c_str());
   at = strchr(tmp, '@');
   if (at)
   {
	  l = f = at - tmp;
	  while (f > 0 && !strchr(Terms, tmp[f - 1]))
		 f--;
	  while (l < strlen(tmp) && !strchr(Terms, tmp[l]))
		 l++;
	  tmp[l] = '\0';
	  addr = AnsiString(&tmp[f]);
   }
   delete tmp;
   return addr.Trim();
}*/
//---------------------------------------------------------------------------

AnsiString __fastcall GetDomain(const AnsiString &FromAddress)
{
   int pos; AnsiString dom;
   if ((pos = FromAddress.Pos("@")) > 0)
	  dom = FromAddress.SubString(pos+1,1024);
   return dom;
}
//---------------------------------------------------------------------------

void __fastcall SetRedraw(TWinControl *window, bool set)
{
   if (!set) window->Perform(WM_SETREDRAW,false,0);
   else
   {
      Application->ProcessMessages();
      window->Perform(WM_SETREDRAW,true,0);
      RedrawWindow(window->Handle,NULL,NULL,RDW_INVALIDATE|RDW_ALLCHILDREN);
   }
}
//---------------------------------------------------------------------------

AnsiString __fastcall dropquotes(AnsiString text)
{
   if (text.Length() > 0)
   {
      if (text[1] == '"')
         text = text.SubString(2, text.Length());
      if (text[text.Length()] == '"')
         text.SetLength(text.Length() - 1);
   }
   return text;
}
//---------------------------------------------------------------------------

int __fastcall GetFileSize(const AnsiString FileName)
{
  TSearchRec SearchRec;
    if(FindFirst(ExpandFileName(FileName), faAnyFile, SearchRec)==0)
      return (int)SearchRec.Size;
    else
      return -1;
}
//---------------------------------------------------------------------------

void __fastcall AssignFont(TFont *font, const AnsiString &spec)
{
   font->Style.Clear();
   AnsiString style = GetTok(2, spec, ',').LowerCase();
   if (style.Pos("b") > 0) font->Style << fsBold;
   if (style.Pos("i") > 0) font->Style << fsItalic;
   if (style.Pos("u") > 0) font->Style << fsUnderline;
   if (style.Pos("s") > 0) font->Style << fsStrikeOut;

   font->Name  = GetTok(0, spec, ',', "ms sans serif");
   font->Size  = GetTok(1, spec, ',').ToIntDef(8);
   font->Color = (TColor)GetTok(3, spec, ',').ToIntDef(0);
}
//---------------------------------------------------------------------------

AnsiString __fastcall GetFontStr(TFont *font)
{
   AnsiString style;
   if (font->Style.Contains(fsItalic)) style += "i";
   if (font->Style.Contains(fsBold)) style += "b";
   if (font->Style.Contains(fsUnderline)) style += "u";
   if (font->Style.Contains(fsStrikeOut)) style += "s";
   if (style.IsEmpty()) style = "r";

   return font->Name + "," + IntToStr(font->Size) + "," + style + "," +
      IntToStr(font->Color);
}
//---------------------------------------------------------------------------

void __fastcall CenterDialog(TForm *CenteredForm, TComponent *OtherForm)
{
   if (!OtherForm) return;
   CenteredForm->Position = poDesigned;
   TForm *CF = CenteredForm;
   TForm *MF = (TForm*)OtherForm;
   CF->Top = MF->Top+((MF->Height-CF->Height)/2);
   CF->Left = MF->Left+((MF->Width-CF->Width)/2);
}
//---------------------------------------------------------------------------

void __fastcall ClearString(AnsiString &string)
{
   ZeroMemory(string.c_str(), string.Length());
   string.SetLength(0);
}
//---------------------------------------------------------------------------

void __fastcall ZeroString(AnsiString &string)
{
   SecureZeroMemory(string.c_str(), string.Length());
   string.SetLength(0);
}
//---------------------------------------------------------------------------

void __fastcall WipeEditBox(TMemo *editbox)
{
   int i = editbox->Perform(WM_GETTEXTLENGTH, 0, 0);
   if (i)
   {
	  char *p = new char[i+1];
	  FillMemory(p, i, ' '); p[i] = '\0';
	  editbox->Perform(WM_SETTEXT, 0, (LPARAM)p);
	  delete p;
   }
}
//---------------------------------------------------------------------------

AnsiString __fastcall GetShortName(const AnsiString &FileName)
{
   char shortname[2048];
   if (!GetShortPathName(FileName.c_str(),shortname, 2048))
	  return GetLastErrorStr();
   return AnsiString(shortname);
}
//---------------------------------------------------------------------------

AnsiString __fastcall GetSysCompatibleFilename(AnsiString filename)
{
   assert(!filename.IsEmpty());
   AnsiString goodchars =
	  "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"
	  "1234567890=_.#$%^&()-+~;@!,";

   for (int i = 1; i <= filename.Length(); i++)
   {
	  if (goodchars.Pos(filename[i]) == 0)
		 filename[i] = '_';
   }

   return filename;
}
//---------------------------------------------------------------------------

AnsiString __fastcall GetAdvancedConfigItem(const AnsiString &Name, const AnsiString &DefValue)
{
   TIniFile *ini = new TIniFile(AppIni());
   AnsiString item = ini->ReadString("advanced", Name, DefValue);
   delete ini;
   return item;
}
//---------------------------------------------------------------------------

int __fastcall GetAdvancedConfigItem(const AnsiString &Name, int DefValue)
{
   TIniFile *ini = new TIniFile(AppIni());
   int item = ini->ReadInteger("advanced", Name, DefValue);
   delete ini;
   return item;
}
//---------------------------------------------------------------------------

bool __fastcall GetAdvancedConfigItem(const AnsiString &Name, bool DefValue)
{
   TIniFile *ini = new TIniFile(AppIni());
   int item = ini->ReadBool("advanced", Name, DefValue);
   delete ini;
   return item;
}
//---------------------------------------------------------------------------

AnsiString __fastcall GetIniItem(const AnsiString &Section, const AnsiString &Name,
   const AnsiString &DefValue)
{
   TIniFile *ini = new TIniFile(AppIni());
   AnsiString item = ini->ReadString(Section, Name, DefValue);
   delete ini;
   return item;
}
//---------------------------------------------------------------------------

int __fastcall GetIniItem(const AnsiString &Section, const AnsiString &Name,
   int DefValue)
{
   TIniFile *ini = new TIniFile(AppIni());
   int item = ini->ReadInteger(Section, Name, DefValue);
   delete ini;
   return item;
}
//---------------------------------------------------------------------------

bool __fastcall GetIniItem(const AnsiString &Section, const AnsiString &Name,
   bool DefValue)
{
   TIniFile *ini = new TIniFile(AppIni());
   int item = ini->ReadBool(Section, Name, DefValue);
   delete ini;
   return item;
}
//---------------------------------------------------------------------------



